const { URLSearchParams } = require("url");
const PixflowCEPManifest = require("pixflow-cep-manifest");
const PixflowUIGeneral = require("pixflow-ui-general");

class NotificationController extends PixflowUIGeneral {
    constructor(){
        super();
        this.notifications = [];
        const cep_manifest = new PixflowCEPManifest();
        this.setProject(cep_manifest.get_item_name());
        this.setPopup(this.getAttribute("popup") || 0);
    }

    setProject(p){
        this.project = p;
    }

    getProject(){
        return this.project;
    }

    setPopup(p){
        this.popup = p;
    }

    getPopup(){
        return this.popup;
    }

    run(){
        const self = this;
        var xhrNotification = new XMLHttpRequest();
        var query = new URLSearchParams({
            project: self.getProject(),
            popup: self.getPopup()
        }).toString();
        xhrNotification.open("GET", `http://dev.motionfactory.io/web/?r=pixflow/light-update2&${query}`, true);
        return new Promise(function(resolve){
            xhrNotification.addEventListener("load", function () {
                self.notifications = JSON.parse(this.responseText);
                resolve(true);
            })
            xhrNotification.send();
        })
    }

    async get_run(){
        await this.run();
    }

}

module.exports = NotificationController;