const PixflowControllerAuth = require("pixflow-controller-auth");
const parse = new DOMParser();
const fs = require("fs");
const path = require("path");
const CepManifest = require("pixflow-cep-manifest");
const cep_manifest = new CepManifest();
require("pixflow-auth-form-email");

class PixflowAuthMotionFactory extends PixflowControllerAuth {
    constructor(){
        super();
    }

    connectedCallback(){

        const self = this;
        const styles = document.createElement("style");
        styles.textContent = fs.readFileSync(path.join(__dirname, "styles.css"));
        this.classList.add(cep_manifest.get_extension_id().split(".")[2]); /* background color image */
        this.appendChild(styles);

        this.template = parse.parseFromString(fs.readFileSync(path.join(__dirname, "template.html")).toString("utf8"), "text/html");
        this.appendChild(this.template.querySelector("div"));

        this.querySelectorAll("ul li").forEach(element => {
            element.addEventListener("click", e => {
                window.cep.util.openURLInDefaultBrowser(element.getAttribute("href"));
            })
        })

        this.querySelector("div > h2").innerHTML = cep_manifest.get_extension_name().replace("Pixflow", "");
        
        this.querySelectorAll(".pixflow, .support, div > div:nth-child(3) > p:nth-child(2) > a").forEach(function(element){
            element.addEventListener("click", self.redirect_click);
        })
        
    }

}

module.exports = PixflowAuthMotionFactory;

