const parse = new DOMParser();
const fs = require("fs");
const path = require("path");
const CepManifest = require("pixflow-cep-manifest");
const cep_manifest = new CepManifest();

class Logout extends HTMLElement {

    constructor(){
        self = super();
    }

    connectedCallback(){
        const style = document.createElement("style");
        style.textContent = fs.readFileSync(path.join(__dirname, "style.css"));
        this.appendChild(style);

        this.template = parse.parseFromString(fs.readFileSync(path.join(__dirname, "template.html")).toString("utf8"), "text/html");

        this.appendChild(this.template.querySelector("div.block"));

        const panel = this.template.querySelector("div.panel");
        panel.classList.add("active");
        setTimeout(() => {
            panel.classList.add("fade");
        }, 100);
        this.appendChild(panel);

        

        panel.querySelector("p > span").innerHTML = cep_manifest.extension_name;

        this.querySelector("button:nth-child(1)").addEventListener("click", this.submit_click)
        this.querySelector("button:nth-child(2)").addEventListener("click", this.cancel_click)
    }

    disconnectedCallback(){
        const panel = this.querySelector("div");
        panel.classList.remove("fade");
        setTimeout(() => {
            panel.classList.remove("active");
        }, 300);
    }

    submit_click(){
        if(cep_manifest.get_extension_id() == "net.pixflow.voiceai")
            localStorage.removeItem("md5");
        else
            localStorage.clear();
        setTimeout(() => {
            window.location.href = cep_manifest.get_main_path();
        }, 200);
    }

    cancel_click(e){
        e.target.parentNode.parentNode.parentNode.remove();
    }

}

customElements.define("pixflow-logout", Logout);

module.exports = Logout;
