const parse = new DOMParser();
const fs = require("fs");
const path = require("path");
const CepManifest = require("pixflow-cep-manifest");
const cep_manifest = new CepManifest();

class PixflowOffline extends HTMLElement {
    constructor(){
        self = super();
    }
    connectedCallback(){
        const style = document.createElement("style");
        style.textContent = fs.readFileSync(path.join(__dirname, "style.css"));
        this.appendChild(style);

        this.template = parse.parseFromString(fs.readFileSync(path.join(__dirname, "template.html")).toString("utf8"), "text/html");
        this.appendChild(this.template.querySelector("div"));
    }
}

customElements.define("pixflow-offline", PixflowOffline);

module.exports = PixflowOffline;
