const fs = require("fs");
const path = require("path");
const PixflowCEPManifest = require("pixflow-cep-manifest");

class PixflowPublishYear extends HTMLElement {

    constructor(){
        super();
        this.cep_manifest = new PixflowCEPManifest();
        const style = document.createElement("style");
        style.textContent = fs.readFileSync(path.join(__dirname, "style.css"));
        this.appendChild(style);
        this.year = this.cep_manifest.get_created_year();
        this.append_parent();
    }

    signature(){
        var today = new Date();
        var yy = today.getFullYear().toString();
        var stryy = this.year;
        if(yy != stryy)
            stryy += "-" + yy;
        return `©${this.cep_manifest.get_extension_name()} ${this.cep_manifest.get_extension_version()} ${stryy} | All rights reserved.`;
    }

    append_parent(){
        const p = document.createElement("p");
        p.innerHTML = this.signature();
        this.appendChild(p);
    }
    
}

customElements.define("pixflow-publish-year", PixflowPublishYear);

module.exports = PixflowPublishYear;
