const parse = new DOMParser();
const fs = require("fs");
const path = require("path");

class PixflowView extends HTMLElement {
    constructor(){
        self = super();
    }
    connectedCallback(){
        const style = document.createElement("style");
        style.textContent = fs.readFileSync(path.join(__dirname, "style.css"));
        this.appendChild(style);

        this.template = parse.parseFromString(fs.readFileSync(path.join(__dirname, "template.html")).toString("utf8"), "text/html");
        this.appendChild(this.template.querySelector("div"));
        this.view = localStorage.getItem("view") || "pixflow-view-small";
        const parent_node = document.querySelectorAll(`${self.getAttribute("parent-node") || "#main, #library"}`);
        parent_node.forEach(el => el.classList.add(self.view));
        this.querySelector(`div > div[data="${this.view}"]`).classList.add("active");

        this.querySelectorAll("div > div").forEach(el => {
            el.addEventListener("click", e => {
                const view = e.target.getAttribute("data");
                document.querySelectorAll(`${self.getAttribute("parent-node") || "#main, #library"}`).forEach(el => {
                    el.classList.remove("pixflow-view-small")
                    el.classList.remove("pixflow-view-large")                    
                });
                localStorage.setItem("view", view);
                e.target.parentNode.querySelectorAll("div").forEach(element => element.classList.remove("active"));
                e.target.classList.add("active");
                document.querySelectorAll(`${self.getAttribute("parent-node") || "#main, #library"}`).forEach(el => {
                    el.classList.add(view);
                });
            })
        })

    }
}

customElements.define("pixflow-view", PixflowView);

module.exports = PixflowView;
