const os = require("os");
const { URLSearchParams } = require("url");
const PixflowCEPManifest = require("pixflow-cep-manifest");

class ReportLogin {
    connect(){
        return new Promise(function(resolve){
            const cep = window.__adobe_cep__;
            const host_env = JSON.parse(cep.getHostEnvironment());
            var app_title;
            switch(host_env.appName){
                case "AEFT": app_title = "After Effects"; break;
                case "PPRO": app_title = "Premiere Pro"; break;
                case "ILST": app_title = "Illustrator"; break;
                case "PHXS": app_title = "Photoshop";
            }
            const cep_manifest = new PixflowCEPManifest()
            var query_data = new URLSearchParams({
                source: cep_manifest.get_source(),
                user_email_address: localStorage.getItem("email"),
                host: app_title,
                version_host: host_env.appVersion,
                os: os.platform().indexOf("win") >= 0 ? "Windows" : "Macintosh",
                plugin_name: cep_manifest.get_extension_name(),
                plugin_version: cep_manifest.get_extension_version()
            }).toString();
            var report_login = new XMLHttpRequest();
            report_login.open("post", `https://pixflow.net/wp-json/pixflow/log-login-data-to-database?${query_data}`);
            report_login.addEventListener("load", function(){
                resolve(true);
            })
            report_login.send();
        })
    }
}

module.exports = ReportLogin;
