class WindowElement extends HTMLElement {
    constructor(){
        super();
        this.animationClass = this.getAttribute("animation-class");
    }

    openWindow(){
        var $this = this;
        $this.classList.add("active");
        setTimeout(() => {
            $this.classList.add($this.animationClass);
        }, 300);
    }

    closeWindow(){
        var $this = this;
        $this.classList.remove($this.animationClass);
        setTimeout(() => {
            $this.classList.remove("active");
        }, 300);
    }
}

customElements.define("window-element", WindowElement);

module.exports = WindowElement;
